<?php
class VIA_Ebay_Block_Adminhtml_Attribute_Grid extends Mage_Adminhtml_Block_Widget_Grid {
	public function __construct() {
		parent::__construct ();
		$this->setId ( 'viaebay_attribute_grid' );
		$this->setDefaultSort ( 'attribute_id' );
		$this->setDefaultDir ( 'ASC' );
		$this->setPagerVisibility ( false );
		$this->setFilterVisibility ( false );
		$this->setUseAjax ( true );
	}
	protected function _prepareCollection() {
		$collection = Mage::getResourceModel ( 'catalog/product_attribute_collection' )->addVisibleFilter ();
		$this->setCollection ( $collection );
		
		parent::_prepareCollection ();
	}
	protected function _preparePage() {
		// Required to remove paging
	}
	protected function _prepareColumns() {
		parent::_prepareColumns ();
		$this->addColumn ( 'attribute_id', array (
				'header' => Mage::helper ( 'viaebay' )->__ ( 'ID' ),
				'type' => 'number',
				'index' => 'attribute_id' 
		) );
		
		$this->addColumn ( 'attribute_code', array (
				'header' => Mage::helper ( 'eav' )->__ ( 'Attribute Code' ),
				'sortable' => true,
				'index' => 'attribute_code' 
		) );
		
		$this->addColumn ( 'frontend_label', array (
				'header' => Mage::helper ( 'eav' )->__ ( 'Attribute Label' ),
				'sortable' => true,
				'index' => 'frontend_label' 
		) );
		
		$this->addColumn ( 'viaebay_export_current', array (
				'header' => Mage::helper ( 'viaebay' )->__ ( 'Current Mapping' ),
				'index' => 'viaebay_attribute',
				'sortable' => true 
		) );
		
		$this->addColumn ( 'viaebay_export', array (
				'header' => Mage::helper ( 'viaebay' )->__ ( 'Mapping' ),
				'index' => 'viaebay_attribute',
				'type' => 'select',
				'options' => Mage::getModel ( 'viaebay/system_config_source_attributes' )->toSelectArray (),
				'editable' => true,
				'sortable' => false,
				'name' => 'attribute',
				'renderer' => 'viaebay/widget_grid_column_renderer_attributeSelect' 
		) );
	}
	public function getGridUrl() {
		return $this->getUrl ( 'adminhtml/viaebay_attribute/grid', array (
				'_current' => true 
		) );
	}
	protected function _getStore() {
		$storeId = ( int ) $this->getRequest ()->getParam ( 'store', 0 );
		return Mage::app ()->getStore ( $storeId );
	}
}