<?php

/**
 * 
 */
class VIA_Ebay_Block_Adminhtml_Backlog_Product_Grid extends Mage_Adminhtml_Block_Widget_Grid {
	public function __construct() {
		parent::__construct ();
		$this->setId ( 'viaebay_backlog_product_grid' );
		$this->setDefaultSort ( 'backlog_id' );
		$this->setDefaultDir ( 'ASC' );
		$this->setUseAjax ( true );
		$this->setSaveParametersInSession ( true );
	}
	protected function _prepareCollection() {
		$collection = Mage::getModel ( 'viaebay/backlog_product' )->getCollection ();
		$collection->getSelect ()->joinLeft ( array (
				'product_table' => $collection->getTable ( 'catalog/product' ) 
		), 'main_table.product_id=product_table.entity_id', array (
				'sku' => 'sku' 
		) );
		$this->setCollection ( $collection );
		return parent::_prepareCollection ();
	}
	protected function _prepareColumns() {
		$this->addColumn ( 'backlog_id', array (
				'header' => Mage::helper ( 'viaebay' )->__ ( 'ID' ),
				'type' => 'number',
				'index' => 'backlog_id' 
		) );
		
		$this->addColumn ( 'product_id', array (
				'header' => Mage::helper ( 'viaebay' )->__ ( 'Product ID' ),
				'type' => 'number',
				'index' => 'product_id' 
		) );
		
		$this->addColumn ( 'sku', array (
				'header' => Mage::helper ( 'viaebay' )->__ ( 'SKU' ),
				'index' => 'sku' 
		) );
		
		$this->addColumn ( 'changes', array (
				'header' => Mage::helper ( 'viaebay' )->__ ( 'Changes' ),
				'index' => 'changes' 
		) );
		
		$this->addColumn ( 'created_at', array (
				'header' => Mage::helper ( 'viaebay' )->__ ( 'Created At' ),
				'type' => 'datetime',
				'index' => 'created_at' 
		) );
		
		// $this->addExportType ( '*/*/exportCsv', Mage::helper ( 'viaebay' )->__ ( 'CSV' ) );
		// $this->addExportType ( '*/*/exportExcel', Mage::helper ( 'viaebay' )->__ ( 'Excel XML' ) );
		
		return parent::_prepareColumns ();
	}
	protected function _prepareMassaction() {
		$this->setMassactionIdField ( 'backlog_id' );
		$this->getMassactionBlock ()->setFormFieldName ( 'backlogIds' );
		$this->getMassactionBlock ()->addItem ( 'delete', array (
				'label' => Mage::helper ( 'viaebay' )->__ ( 'Delete' ),
				'url' => $this->getUrl ( 'adminhtml/viaebay_backlog_product/massDelete', array () ),
				'confirm' => Mage::helper ( 'viaebay' )->__ ( 'Are you sure?' ) 
		) );
		
		return $this;
	}
	public function getRowUrl($row) {
		return $this->getUrl ( 'adminhtml/catalog_product/edit', array (
				'id' => $row->getProductId () 
		) );
	}
	public function getGridUrl() {
		return $this->getUrl ( 'adminhtml/viaebay_backlog_product/grid', array (
				'_current' => true 
		) );
	}
}