<?php

/**
 * Clear log button renderer
 *
 * @category   VIA
 * @package    VIA_Ebay
 */
class VIA_Ebay_Block_System_Config_ClearLog extends Mage_Adminhtml_Block_System_Config_Form_Field {
	/*
	 * Set template
	 */
	protected function _construct() {
		parent::_construct ();
		$this->setTemplate ( 'viaebay/system/config/clearLog.phtml' );
	}
	
	/**
	 * Remove scope label
	 *
	 * @param Varien_Data_Form_Element_Abstract $element        	
	 * @return string
	 */
	public function render(Varien_Data_Form_Element_Abstract $element) {
		$element->unsScope ()->unsCanUseWebsiteValue ()->unsCanUseDefaultValue ();
		return parent::render ( $element );
	}
	
	/**
	 * Return element html
	 *
	 * @param Varien_Data_Form_Element_Abstract $element        	
	 * @return string
	 */
	protected function _getElementHtml(Varien_Data_Form_Element_Abstract $element) {
		return $this->_toHtml ();
	}
	
	/**
	 * Return ajax url for synchronize button
	 *
	 * @return string
	 */
	public function getClearLogUrl() {
		return Mage::getSingleton ( 'adminhtml/url' )->getUrl ( 'adminhtml/viaebay_config/clearLog' );
	}
	
	/**
	 * Generate synchronize button html
	 *
	 * @return string
	 */
	public function getButtonHtml() {
		$button = $this->getLayout ()->createBlock ( 'adminhtml/widget_button' )->setData ( array (
				'id' => 'clear_log_button',
				'label' => $this->helper ( 'viaebay' )->__ ( 'Clear log' ),
				'onclick' => 'javascript:viaebayClearLog(); return false;' 
		) );
		
		return $button->toHtml ();
	}
}
