<?php
class VIA_Ebay_Helper_Data extends Mage_Core_Helper_Abstract {
	const STORE_VIEW_CONFIG = 'viaebay/connection/store_view';
	const LOGGING_ENABLED = 'viaebay/connection/enable_logging';
	private $_viaStore = null;
	private $_viaRootCategory = null;
	
	/**
	 *
	 * @return string
	 */
	public function getExtensionVersion() {
		return ( string ) Mage::getConfig ()->getModuleConfig ( 'VIA_Ebay' )->version;
	}
	
	/**
	 *
	 * @return Mage_Core_Model_Store
	 */
	public function getVIAStore() {
		if ($this->_viaStore == null) {
			$this->_viaStore = Mage::app ()->getStore ( Mage::getStoreConfig ( self::STORE_VIEW_CONFIG ) );
		}
		return $this->_viaStore;
	}
	
	/**
	 *
	 * @return NULL|integer
	 */
	public function getVIAStoreId() {
		$store = $this->getVIAStore ();
		if ($store == null) {
			return null;
		} else {
			return $store->getId ();
		}
	}
	
	/**
	 *
	 * @return integer
	 */
	public function getVIARootCategoryId() {
		return $this->getVIAStore ()->getRootCategoryId ();
	}
	
	/**
	 *
	 * @return Mage_Catalog_Model_Category
	 */
	public function getVIARootCategory() {
		if ($this->_viaRootCategory == null) {
			$this->_viaRootCategory = Mage::getModel ( 'viaebay/category', array (
					'disable_flat' => true 
			) )->setStoreId ( $this->getVIAStoreId () )->load ( $this->getVIARootCategoryId () );
		}
		return $this->_viaRootCategory;
	}
	
	/**
	 * Calculate price without tax
	 *
	 * @param float $price
	 *        	with tax
	 * @param float $tax
	 *        	tax amount. If $tax > 1 $tax is assumed to be in percent.
	 */
	public function priceWithoutTax($price, $tax) {
		if ($tax > 1) {
			$tax = $tax / 100;
		}
		
		return $price / (1 + $tax);
	}
	
	/**
	 * Parse API Date.
	 *
	 * @param string $field
	 * @param array $arr
	 * @return string
	 */
	public static function parseDate($date) {
		if ($date != '' && preg_match ( '|/Date\((\d*)\)/|', $date, $match )) {
			if (isset ( $match [1] ) && $match [1] != '') {
				return date ( 'c', $match [1] / 1000 );
			}
		}
		return '';
	}
}
