<?php

/**
 * Category model used to disable flat tables.
 *
 */
class VIA_Ebay_Model_Category extends Mage_Catalog_Model_Category {
	/**
	 * Initialize resource mode
	 *
	 * @return void
	 */
	protected function _construct() {
		$this->_init ( 'viaebay/category' );
		$this->_useFlatResource = false;
	}
	
	/**
	 * Retrieve disable flat flag value
	 *
	 * @return bool
	 */
	public function getDisableFlat() {
		return true;
	}
	
	/**
	 * Return store id.
	 *
	 * If store id is underfined for category return current VIA-Connect store id
	 *
	 * @return integer
	 */
	public function getStoreId() {
		if ($this->hasData ( 'store_id' )) {
			return $this->_getData ( 'store_id' );
		}
		return Mage::helper ( 'viaebay/data' )->getVIAStoreId ();
	}
}
