<?php

/**
 * Cron handler for VIA-Connect.
 *
 * @category	VIA
 * @package		VIA_Ebay
 * @subpackage	Model
 */
class VIA_Ebay_Model_Cron {
	const SYNC_CATALOG = 'viaebay_sync_catalog';
	const SYNC_ORDERS = 'viaebay_sync_orders';
	public static $CRONJOBS = array (
			self::SYNC_CATALOG,
			self::SYNC_ORDERS 
	);
	
	/**
	 * Sync catalog.
	 */
	public function syncCatalog() {
		try {
			return Mage::getSingleton ( 'viaebay/service_catalog' )->export ();
		} catch ( Exception $e ) {
			$session = Mage::getSingleton ( 'adminhtml/session' );
			/* @var $session Mage_Adminhtml_Model_Session */
			$session->addError ( $e->getMessage () );
			Mage::helper ( 'viaebay/log' )->logException ( $e );
		}
		return null;
	}
	
	/**
	 * Sync orders.
	 */
	public function syncOrders() {
		try {
			return Mage::getSingleton ( 'viaebay/service_order' )->import ();
		} catch ( Exception $e ) {
			$session = Mage::getSingleton ( 'adminhtml/session' );
			/* @var $session Mage_Adminhtml_Model_Session */
			$session->addError ( $e->getMessage () );
			Mage::helper ( 'viaebay/log' )->logException ( $e );
		}
		return null;
	}
	
	/**
	 * Sync price and stock.
	 */
	public function syncPriceAndStock() {
		try {
			return Mage::getSingleton ( 'viaebay/service_catalog' )->syncPriceAndStock ();
		} catch ( Exception $e ) {
			$session = Mage::getSingleton ( 'adminhtml/session' );
			/* @var $session Mage_Adminhtml_Model_Session */
			$session->addError ( $e->getMessage () );
			Mage::helper ( 'viaebay/log' )->logException ( $e );
		}
		return null;
	}
}