<?php
class VIA_Ebay_Model_Exception_Client extends VIA_Ebay_Model_Exception_Abstract {
	private $method;
	private $uri;
	private $request;
	private $response;
	private $status;
	
	/**
	 * Construct the exception
	 *
	 * @param string $method        	
	 * @param string $uri        	
	 * @param string $request        	
	 * @param string $response        	
	 * @param int $status;        	
	 * @param string $msg        	
	 * @param int $code        	
	 * @param Exception $previous        	
	 * @return void
	 */
	public function __construct($method, $uri, $request, $response, $status, $msg = '', $code = 0, Exception $previous = null) {
		parent::__construct ( $msg, $code, $previous );
		$this->method = $method;
		$this->uri = $uri;
		$this->request = $request;
		$this->response = $response;
		$this->status = $status;
	}
	
	/**
	 *
	 * @return string
	 */
	public function getMethod() {
		return $this->message;
	}
	
	/**
	 *
	 * @return string
	 */
	public function getUri() {
		return $this->uri;
	}
	
	/**
	 *
	 * @return string
	 */
	public function getRequest() {
		return $this->request;
	}
	
	/**
	 *
	 * @return string
	 */
	public function getResponse() {
		return $this->response;
	}
	
	/**
	 */
	public function getStatus() {
		return $this->status;
	}
	
	/**
	 * (non-PHPdoc)
	 * @see Zend_Exception::__toString()
	 */
	public function __toString() {
		$response = parent::__toString () . "\n";
		$response .= $this->getMethod () . " " . $this->getUri () . " " . $this->getStatus () . "\n";
		$response .= $this->getRequest () . "\n";
		$response .= $this->getResponse () . "\n";
	}
}
