<?php
class VIA_Ebay_Model_Payment extends Mage_Payment_Model_Method_Abstract {
	protected $_code = 'viaebay';
	protected $_formBlockType = 'viaebay/payment_form';
	protected $_infoBlockType = 'viaebay/payment_info';
	
	/**
	 * Payment Method features
	 * @bool
	 */
	protected $_isGateway = true;
	protected $_canOrder = true;
	protected $_canAuthorize = true;
	protected $_canCapture = true;
	protected $_canCapturePartial = true;
	protected $_canRefund = true;
	protected $_canRefundInvoicePartial = true;
	protected $_canVoid = false;
	protected $_canUseInternal = false;
	protected $_canUseCheckout = false;
	protected $_canUseForMultishipping = false;
	protected $_isInitializeNeeded = false;
	protected $_canFetchTransactionInfo = false;
	protected $_canReviewPayment = false;
	protected $_canCreateBillingAgreement = false;
	protected $_canManageRecurringProfiles = false;
	protected $_canCancelInvoice = false;
	
	/**
	 * Can be edit order (renew order)
	 *
	 * @return bool
	 */
	public function canEdit() {
		return false;
	}
	
	/**
	 * Capture payment.
	 *
	 * @param Varien_Object $orderPayment        	
	 * @param double $amount        	
	 * @return VIA_Ebay_Model_Payment
	 */
	public function capture(Varien_Object $payment, $amount) {
		if ($payment instanceof Mage_Sales_Model_Order_Payment) {
			Mage::getSingleton ( 'viaebay/service_order' )->updatePaid ( $payment, $amount );
		}
		
		return $this;
	}
	
	/**
	 * Refund specified amount for payment.
	 *
	 * @param Varien_Object $payment        	
	 * @param float $amount        	
	 * @return VIA_Ebay_Model_Payment
	 */
	public function refund(Varien_Object $payment, $amount) {
		if ($amount > 0) {
			$amount = - amount;
		}
		
		if ($payment instanceof Mage_Sales_Model_Order_Payment) {
			Mage::getSingleton ( 'viaebay/service_order' )->updatePaid ( $payment, $amount );
		}
		
		return $this;
	}
	public function assignData($data) {
		if (! ($data instanceof Varien_Object)) {
			$data = new Varien_Object ( $data );
		}
		$info = $this->getInfoInstance ();
		$info->setViaebayRemoteMethod ( $data->getViaebayRemoteMethod () );
		$info->setViaebayPaymentTransactionId ( $data->getViaebayPaymentTransactionId () );
		$info->setViaebayBuyerName ( $data->getViaebayBuyerName () );
		$info->setViaebayBuyerPackageEnclosure ( $data->getViaebayBuyerPackageEnclosure () );
		return $this;
	}
}
