<?php

/**
 * 
 */
class VIA_Ebay_Model_Resource_Attribute extends Mage_Core_Model_Resource_Db_Abstract {
	/**
	 * Constructor
	 */
	protected function _construct() {
		$this->_init ( 'eav/attribute', 'attribute_id' );
	}
	
	/**
	 * Retrieve map of attribute code to label.
	 *
	 * @param int $storeId
	 *        	The specific attribute set
	 * @return array
	 */
	public function getProductAttributeLabels($storeId) {
		if ($storeId instanceof Mage_Core_Model_Store) {
			$storeId = $storeId->getId ();
		}
		
		/* @var $entityType Mage_Eav_Model_Entity_Type */
		$entityType = Mage::getModel ( 'eav/entity' )->setType ( Mage_Catalog_Model_Product::ENTITY );
		
		$adapter = $this->_getReadAdapter ();
		$select = $adapter->select ()->from ( array (
				'a' => $this->getMainTable () 
		), '*' )->joinLeft ( array (
				'l' => $this->getTable ( 'eav/attribute_label' ) 
		), 'l.attribute_id = a.attribute_id AND l.store_id = :store_id', array (
				'store_label' => 'value' 
		) )->where ( 'a.entity_type_id = :entity_type_id' );
		
		$bind = array (
				'store_id' => $storeId,
				'entity_type_id' => $entityType->getTypeId () 
		);
		
		$attributes = array ();
		
		$result = $adapter->fetchAll ( $select, $bind );
		foreach ( $result as $data ) {
			$attributes [$data ['attribute_code']] = $data ['store_label'] ?: $data ['frontend_label'];
		}
		
		return $attributes;
	}
}
