<?php

/**
 * Resource for custom order model.
 */
class VIA_Ebay_Model_Resource_Order extends Mage_Core_Model_Resource_Db_Abstract {
	/**
	 * Initialize domain model and set primary key
	 *
	 * @return void
	 */
	protected function _construct() {
		$this->_init ( 'viaebay/order', 'order_id' );
	}
	
	/**
	 * Prepare data for save
	 *
	 * @param Mage_Core_Model_Abstract $object        	
	 * @return array
	 */
	protected function _prepareDataForSave(Mage_Core_Model_Abstract $object) {
		$currentTime = Varien_Date::now ();
		if ((! $object->getId () || $object->isObjectNew ()) && ! $object->getCreatedAt ()) {
			$object->setCreatedAt ( $currentTime );
		}
		$object->setUpdatedAt ( $currentTime );
		return parent::_prepareDataForSave ( $object );
	}
}