<?php
class VIA_Ebay_Adminhtml_Viaebay_AttributeController extends Mage_Adminhtml_Controller_Action {
	protected function _initAction() {
		$this->loadLayout ()->_setActiveMenu ( 'viaebay/products' )->_addBreadcrumb ( Mage::helper ( 'viaebay' )->__ ( 'Attribute Mapping' ), Mage::helper ( 'viaebay' )->__ ( 'Attribute Mapping' ) );
		return $this;
	}
	protected function _isAllowed() {
		return Mage::getSingleton ( 'admin/session' )->isAllowed ( 'admin/viaebay/attributes' );
	}
	public function indexAction() {
		$this->_initAction ();
		$this->_initLayoutMessages ( 'adminhtml/session' );
		$this->renderLayout ();
	}
	public function saveAction() {
		$attribute = ( array ) $this->getRequest ()->getParam ( 'attribute' );
		$storeId = ( int ) $this->getRequest ()->getParam ( 'store', 0 );
		
		/* @var $log VIA_Ebay_Helper_Log */
		$log = Mage::helper ( 'viaebay/log' );
		
		$log->logToFile ( json_encode ( $attribute ), Zend_Log::DEBUG );
		
		$seen = array ();
		$count = 0;
		
		$transaction = Mage::getSingleton ( 'core/resource' )->getConnection ( 'core_write' );
		try {
			$transaction->beginTransaction ();
			$attributeCollection = Mage::getResourceModel ( 'catalog/product_attribute_collection' )->addVisibleFilter ();
			
			foreach ( $attributeCollection as $attributeModel ) {
				if (array_key_exists ( $attributeModel->getAttributeCode (), $attribute )) {
					$viaAttr = $attribute [$attributeModel->getAttributeCode ()];
					if (array_key_exists ( $viaAttr, $seen ) && $viaAttr != 'None' && $viaAttr != 'CustomAttribute' && $viaAttr != 'OptionalAttribute') {
						Mage::getSingleton ( 'adminhtml/session' )->addError ( $this->__ ( 'Skipping duplicate %s', $viaAttr ) );
						$viaAttr = 'None';
					}
					
					$seen [$viaAttr] = true;
					
					if ($attributeModel->getData ( 'viaebay_attribute' ) != $viaAttr) {
						$attributeModel->setData ( 'viaebay_attribute', $viaAttr );
						try {
							$attributeModel->save ();
							$count ++;
						} catch ( Exception $e ) {
							$log->logException ( $e );
						}
					} else {
						// Mage::getSingleton ( 'adminhtml/session' )->addWarning ( $this->__ ( 'Attribute %s not changed', $attributeModel->getAttributeCode () ) );
					}
				} else {
					Mage::getSingleton ( 'adminhtml/session' )->addError ( $this->__ ( 'Attribute %s not found', $attributeModel->getAttributeCode () ) );
				}
			}
			
			$transaction->commit ();
		} catch ( Exception $e ) {
			Mage::helper ( 'viaebay/log' )->logException ( $e );
			$transaction->rollback ();
		}
		
		Mage::getSingleton ( 'adminhtml/session' )->addSuccess ( $this->__ ( 'Updated %d attributes', $count ) );
		
		$this->_redirect ( '*/*/', array (
				'store' => $storeId 
		) );
	}
	
	/**
	 * Product grid for AJAX request.
	 * Sort and filter result for example.
	 */
	public function gridAction() {
		$this->loadLayout ();
		$this->getResponse ()->setBody ( $this->getLayout ()->createBlock ( 'viaebay/adminhtml_attribute_grid' )->toHtml () );
	}
}
