<?php
class VIA_Ebay_Adminhtml_Viaebay_Backlog_ProductController extends Mage_Adminhtml_Controller_Action {
	protected function _initAction() {
		$this->loadLayout ()->_setActiveMenu ( 'viaebay/backlog' )->_addBreadcrumb ( Mage::helper ( 'viaebay' )->__ ( 'Backlog' ), Mage::helper ( 'viaebay' )->__ ( 'Backlog' ) );
		return $this;
	}
	protected function _isAllowed() {
		return Mage::getSingleton ( 'admin/session' )->isAllowed ( 'admin/viaebay/backlog' );
	}
	public function indexAction() {
		$this->_initAction ()->renderLayout ();
	}
	public function exportCsvAction() {
		$fileName = 'backlog.csv';
		$grid = $this->getLayout ()->createBlock ( 'viaebay/adminhtml_backlog_product_grid' );
		$this->_prepareDownloadResponse ( $fileName, $grid->getCsvFile () );
	}
	public function exportExcelAction() {
		$fileName = 'backlog.xml';
		$grid = $this->getLayout ()->createBlock ( 'viaebay/adminhtml_backlog_product_grid' );
		$this->_prepareDownloadResponse ( $fileName, $grid->getExcelFile ( $fileName ) );
	}
	public function massDeleteAction() {
		$backlogIds = $this->getRequest ()->getParam ( 'backlogIds' );
		if (! is_array ( $backlogIds )) {
			Mage::getSingleton ( 'adminhtml/session' )->addError ( Mage::helper ( 'viaebay' )->__ ( 'Please select backlog entries.' ) );
		} else {
			try {
				$backlogModel = Mage::getModel ( 'viaebay/backlog_product' );
				foreach ( $backlogIds as $backlogId ) {
					$backlogModel->load ( $backlogId )->delete ();
				}
				Mage::getSingleton ( 'adminhtml/session' )->addSuccess ( Mage::helper ( 'viaebay' )->__ ( 'Total of %d record(s) were deleted.', count ( $backlogIds ) ) );
			} catch ( Exception $e ) {
				Mage::getSingleton ( 'adminhtml/session' )->addError ( $e->getMessage () );
			}
		}
		$this->_redirect ( '*/*/index' );
	}
	
	/**
	 * Mass add products to backlog
	 */
	public function massAddToBacklogAction() {
		$productIds = $this->getRequest ()->getPost ( 'product', array () );
		
		/* @var $backlogHelper VIA_Ebay_Helper_Backlog */
		$backlogHelper = Mage::helper ( 'viaebay/backlog' );
		
		$productsAddedToBacklog = 0;
		
		foreach ( $productIds as $id ) {
			$backlogHelper->createBacklog ( $id, 'manual' );
			$productsAddedToBacklog ++;
		}
		
		if ($productsAddedToBacklog > 0) {
			Mage::getSingleton ( 'adminhtml/session' )->addSuccess ( Mage::helper ( 'viaebay' )->__ ( 'Total %d of %d product(s) were added to backlog.', $productsAddedToBacklog, count ( $productIds ) ) );
		} else {
			Mage::getSingleton ( 'adminhtml/session' )->addError ( Mage::helper ( 'viaebay' )->__ ( 'No product(s) added to backlog.' ) );
		}
		
		$this->_redirect ( 'adminhtml/catalog_product/index' );
	}
	
	/**
	 * Product grid for AJAX request.
	 * Sort and filter result for example.
	 */
	public function gridAction() {
		$this->loadLayout ();
		$this->getResponse ()->setBody ( $this->getLayout ()->createBlock ( 'viaebay/adminhtml_backlog_product_grid' )->toHtml () );
	}
	
	/**
	 * Mass action: schedule
	 *
	 * @return void
	 */
	public function scheduleAction() {
		$redirect = $this->getRequest ()->getParam ( "redirect", "order" );
		$cronjobs = $this->getCronjobs ();
		Mage::helper ( 'viaebay/cron' )->scheduleJobs ( $cronjobs, true );
		if ($redirect === "backlog_product") {
			$this->_redirect ( 'adminhtml/viaebay_backlog_product/index' );
			return;
		}
		
		$this->_redirect ( 'adminhtml/viaebay_order/index' );
	}
	
	/**
	 * Mass action: run
	 *
	 * @return void
	 */
	public function runAction() {
		$redirect = $this->getRequest ()->getParam ( "redirect", "order" );
		$cronjobs = $this->getCronjobs ();
		Mage::helper ( 'viaebay/cron' )->runJobs ( $cronjobs, true );
		if ($redirect === "backlog_product") {
			$this->_redirect ( 'adminhtml/viaebay_backlog_product/index' );
			return;
		}
		
		$this->_redirect ( 'adminhtml/viaebay_order/index' );
	}
	
	/**
	 * Get cronjobs from request.
	 *
	 * @return array of cronjobs
	 */
	private function getCronjobs() {
		$cronjob = $this->getRequest ()->getParam ( 'cronjob', 'all' );
		if ($cronjob == 'all') {
			return VIA_Ebay_Model_Cron::$CRONJOBS;
		} else if (in_array ( $cronjob, VIA_Ebay_Model_Cron::$CRONJOBS )) {
			return array (
					$cronjob 
			);
		}
		return null;
	}
}
