<?php
class VIA_Ebay_Adminhtml_Viaebay_ProductController extends Mage_Adminhtml_Controller_Action {
	protected function _initAction() {
		$this->loadLayout ()->_setActiveMenu ( 'viaebay/products' )->_addBreadcrumb ( Mage::helper ( 'viaebay' )->__ ( 'Products' ), Mage::helper ( 'viaebay' )->__ ( 'Products' ) );
		return $this;
	}
	protected function _isAllowed() {
		return Mage::getSingleton ( 'admin/session' )->isAllowed ( 'admin/viaebay/products' );
	}
	public function indexAction() {
		$this->_initAction ()->renderLayout ();
	}
	public function massTransferAction() {
		$productIds = ( array ) $this->getRequest ()->getParam ( 'productIds' );
		$storeId = ( int ) $this->getRequest ()->getParam ( 'store', 0 );
		$async = ( int ) $this->getRequest ()->getParam ( 'async', 0 );
		
		foreach ( $productIds as $productId ) {
			Mage::helper ( 'viaebay/backlog' )->createBacklog ( $productId );
		}

		if ($async) {
			Mage::helper ( 'viaebay/cron' )->scheduleJobs ( array (
					VIA_Ebay_Model_Cron::SYNC_CATALOG 
			), true );
		} else {
			Mage::helper ( 'viaebay/cron' )->runJobs ( array (
					VIA_Ebay_Model_Cron::SYNC_CATALOG 
			), true );
		}
		$this->_redirect ( '*/*/', array (
				'store' => $storeId 
		) );
	}
	public function massEnableAction() {
		$productIds = ( array ) $this->getRequest ()->getParam ( 'productIds' );
		$storeId = ( int ) $this->getRequest ()->getParam ( 'store', 0 );
		
		try {
			Mage::getSingleton ( 'catalog/product_action' )->updateAttributes ( $productIds, array (
					'viaebay_export' => 1 
			), $storeId );
			
			$this->massTransferAction ();
			$this->_getSession ()->addSuccess ( $this->__ ( 'Total of %d record(s) have been updated.', count ( $productIds ) ) );
		} catch ( Mage_Core_Model_Exception $e ) {
			$this->_getSession ()->addError ( $e->getMessage () );
		} catch ( Mage_Core_Exception $e ) {
			$this->_getSession ()->addError ( $e->getMessage () );
		} catch ( Exception $e ) {
			$this->_getSession ()->addException ( $e, $this->__ ( 'An error occurred while updating the product(s) status.' ) );
		}
		
		$this->_redirect ( '*/*/', array (
				'store' => $storeId 
		) );
	}
	public function massDisableAction() {
		$productIds = ( array ) $this->getRequest ()->getParam ( 'productIds' );
		$storeId = ( int ) $this->getRequest ()->getParam ( 'store', 0 );
		
		try {
			Mage::getSingleton ( 'catalog/product_action' )->updateAttributes ( $productIds, array (
					'viaebay_export' => 0 
			), $storeId );
			
			$this->massTransferAction ();
			$this->_getSession ()->addSuccess ( $this->__ ( 'Total of %d record(s) have been updated.', count ( $productIds ) ) );
		} catch ( Mage_Core_Model_Exception $e ) {
			$this->_getSession ()->addError ( $e->getMessage () );
		} catch ( Mage_Core_Exception $e ) {
			$this->_getSession ()->addError ( $e->getMessage () );
		} catch ( Exception $e ) {
			$this->_getSession ()->addException ( $e, $this->__ ( 'An error occurred while updating the product(s) status.' ) );
		}
		
		$this->_redirect ( '*/*/', array (
				'store' => $storeId 
		) );
	}
	
	/**
	 * Product grid for AJAX request.
	 * Sort and filter result for example.
	 */
	public function gridAction() {
		$this->loadLayout ();
		$this->getResponse ()->setBody ( $this->getLayout ()->createBlock ( 'viaebay/adminhtml_product_grid' )->toHtml () );
	}
}
