<?php
/* @var $installer VIA_Ebay_Model_Resource_Eav_Mysql4_Setup */
$installer = $this;
$installer->startSetup ();

$installer->addAttribute ( 'catalog_category', 'viaebay_id', array (
		'type' => 'int',
		'label' => 'Category VIA-Connect Id',
		'input' => 'text',
		'required' => false,
		'sort_order' => 1,
		'global' => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
		'user_defined' => false,
		'visible' => false,
		'group' => 'VIA-Connect' 
) );

$installer->addAttribute ( 'catalog_product', 'viaebay_id', array (
		'type' => 'int',
		'label' => 'Product VIA-Connect Id',
		'required' => false,
		'global' => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
		'visible' => false,
		'group' => 'VIA-Connect' 
) );

$installer->addAttribute ( 'catalog_product', 'viaebay_variant_ids', array (
		'type' => 'text',
		'label' => 'VIA-Connect Variant Ids',
		'required' => false,
		'global' => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
		'visible' => false,
		'group' => 'VIA-Connect' 
) );

$installer->addAttribute ( 'catalog_product', 'viaebay_export', array (
		'type' => 'int',
		'label' => 'Export to VIA-Connect',
		'input' => 'select',
		'source' => 'eav/entity_attribute_source_boolean',
		'required' => false,
		'global' => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
		'visible' => true,
		'group' => 'VIA-Connect' 
) );

$installer->addAttribute ( 'catalog_product', 'viaebay_shipping_profile_id', array (
		'type' => 'int',
		'label' => 'VIA-Connect Shipping Profile',
		'required' => false,
		'global' => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
		'visible' => true,
		'group' => 'VIA-Connect' 
) );

$installer->addAttribute ( 'catalog_product', 'viaebay_auto_accept_price', array (
		'type' => 'decimal',
		'label' => 'BestOffer Autoaccept Price',
		'input' => 'price',
		'backend' => 'catalog/product_attribute_backend_price',
		'required' => false,
		'global' => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
		'visible' => true,
		'group' => 'VIA-Connect' 
) );

$installer->addAttribute ( 'catalog_product', 'viaebay_auto_decline_price', array (
		'type' => 'decimal',
		'label' => 'BestOffer Autodecline Price',
		'input' => 'price',
		'backend' => 'catalog/product_attribute_backend_price',
		'required' => false,
		'global' => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
		'visible' => true,
		'group' => 'VIA-Connect' 
) );

$installer->addAttribute ( 'order', 'viaebay_id', array (
		'type' => 'int',
		'label' => 'Order VIA-Connect Id',
		'required' => false,
		'visible' => false 
) );

$installer->addAttribute ( 'customer', 'viaebay_buyer_id', array (
		'type' => 'int',
		'label' => 'VIA-Connect Buyer Id',
		'input' => 'text',
		'required' => false,
		'sort_order' => 200,
		'visible' => false 
) );

$installer->addAttribute ( 'customer', 'viaebay_buyer_name', array (
		'type' => 'varchar',
		'label' => 'VIA-Connect Buyer Name',
		'input' => 'text',
		'required' => false,
		'sort_order' => 201,
		'visible' => false 
) );

$installer->run ( "
		ALTER TABLE `{$installer->getTable('sales/quote_payment')}` ADD `viaebay_buyer_package_enclosure` VARCHAR( 255 );
		ALTER TABLE `{$installer->getTable('sales/order_payment')}` ADD `viaebay_buyer_package_enclosure` VARCHAR( 255 );
		" );

$installer->endSetup ();
