<?php
/* @var $installer VIA_Ebay_Model_Resource_Eav_Mysql4_Setup */
$installer = $this;
$installer->startSetup ();

$installer->run ( "

DROP TABLE IF EXISTS {$this->getTable('viaebay_order')};
CREATE TABLE {$this->getTable('viaebay_order')} (
	`order_id` int(11) unsigned NOT NULL auto_increment,
	`viaebay_order_id` int(11) unsigned NOT NULL UNIQUE,
	`magento_order_id` int(11) unsigned,
	`platform_order_id` varchar(255),
	`buyer_name` varchar(255) NOT NULL,
	`message` text,
	`error` text,
	`checkout_complete_date` datetime default '0000-00-00 00:00:00',
	`created_at` datetime default '0000-00-00 00:00:00',
	`updated_at` datetime default '0000-00-00 00:00:00',
	PRIMARY KEY (`order_id`),
	CONSTRAINT `FK_VIAEBAY_ORDER_MAGENTO_ORDER_ID` FOREIGN KEY (`magento_order_id`) REFERENCES {$installer->getTable('sales_flat_order')} (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

" );

$attributeCollection = Mage::getResourceModel ( 'catalog/product_attribute_collection' )->addVisibleFilter ();

foreach ( $attributeCollection as $attributeModel ) {
	switch ($attributeModel->getViaebayAttribute ()) {
		case 'Custom Attribute' :
			$attributeModel->setData ( 'viaebay_attribute', 'CustomAttribute' );
			$attributeModel->save ();
			break;
		case 'Optional Attribute' :
			$attributeModel->setData ( 'viaebay_attribute', 'OptionalAttribute' );
			$attributeModel->save ();
			break;
	}
}

$installer->endSetup ();
