<?php
require_once 'abstract.php';

/**
 * Update Orders
 *
 * @category VIA
 * @package VIA_Ebay
 * @subpackage VIA_Ebay_Shell
 */
class VIA_Ebay_Shell_SyncPriceAndStock extends Mage_Shell_Abstract {
	/**
	 * Export catalog for VIA-Connect.
	 *
	 * @return VIA_Ebay_Shell_CatalogUpdate
	 */
	public function run() {
		try {
			ini_set ( 'memory_limit', '-1' );
			/* @var $service VIA_Ebay_Model_Service_Catalog */
			$service = Mage::getSingleton ( 'viaebay/service_catalog' );
			echo "Exporting\n";
			$count = $service->syncPriceAndStock ();
			var_dump ( $count->getData () );
			echo "Exported\n";
		} catch ( Exception $e ) {
			echo $e->__toString ();
		}
		
		return $this;
	}
	
	/**
	 * Retrieve Usage Help Message
	 */
	public function usageHelp() {
		return <<<USAGE
Usage:  php -f viaebay-catalog-syncPriceAndStock.php -- [options]

  --help     This help
\n
USAGE;
	}
}

(new VIA_Ebay_Shell_SyncPriceAndStock ())->run ();
