<?php
require_once 'abstract.php';

/**
 * Update Orders
 *
 * @category VIA
 * @package VIA_Ebay
 * @subpackage VIA_Ebay_Shell
 */
class VIA_Ebay_Shell_OrderUpdate extends Mage_Shell_Abstract {
	/**
	 * Update orders for VIA-Connect.
	 *
	 * @return VIA_Ebay_Shell_OrderUpdate
	 */
	public function run() {
		try {
			ini_set ( 'memory_limit', '-1' );
			/* @var $service VIA_Ebay_Model_Service_Order */
			$service = Mage::getSingleton ( 'viaebay/service_order' );
			$service->import ();
		} catch ( Exception $e ) {
			echo $e->__toString ();
		}
		
		return $this;
	}
	
	/**
	 * Retrieve Usage Help Message
	 */
	public function usageHelp() {
		return <<<USAGE
Usage:  php -f viaebay-order-update.php -- [options]

  --help     This help
\n
USAGE;
	}
}

(new VIA_Ebay_Shell_OrderUpdate ())->run ();
